<?
# status.php
#
# Costruisce una pagina con le informazioni sullo stato del server
# prelevate dai FIFO di smartmonitor, dalle entry in /proc di lm_sensors
# e dal file /var/log/upsstatus dell'UPS
#
# Versione PHP
#
# (C) I1EPJ 2004
#

$MYURL="http://ir1bi.1.it.ampr.org/img";
$MYSMFIFOPATH="/var/spool/smartmonitor";
$LMSENSORSPATH="/proc/sys/dev/sensors/w83781d-isa-0290";
$UPSSTATUSFILE="/var/log/apcupsd.status";
$UPTIMEFILE="/proc/uptime";
#
# Lettura dei FIFO di SmartMonitor 
# I dati sono letti due volte per rimuovere i vecchi valori
#
$fp = fopen("$MYSMFIFOPATH/temp", "r");
$Temp = fgets($fp);
$Temp = fgets($fp);
fclose($fp);

$fp = fopen("$MYSMFIFOPATH/valim", "r");
$Valim = fgets($fp);
$Valim = fgets($fp);
fclose($fp);

$fp = fopen("$MYSMFIFOPATH/din1", "r");
$SW1 = fgets($fp);
$SW1 = fgets($fp);
fclose($fp);

$fp = fopen("$MYSMFIFOPATH/din2", "r");
$SW2 = fgets($fp);
$SW2 = fgets($fp);
fclose($fp);

$fp = fopen("$MYSMFIFOPATH/din3", "r");
$SW3 = fgets($fp);
$SW3 = fgets($fp);
fclose($fp);

$fp = fopen("$MYSMFIFOPATH/din4", "r");
$SW4 = fgets($fp);
$SW4 = fgets($fp);
fclose($fp);
# 
# Lettura dati da lm_sensors (tensioni, ventole, ecc.)
# 
$fp = fopen("$LMSENSORSPATH/temp2","r");
$CPUTemp = substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/temp1","r");
$SYSTemp=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/in0","r");
$VCore1=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/in1","r");
$VCore2=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/in2","r");
$P33V=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/in3","r");
$P5VR=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/in4","r");
$P12VR=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/in5","r");
$M12VR=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/in6","r");
$M5VR=substr(fgets($fp),10);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/fan3","r");
$SYSFan=substr(fgets($fp),5);
fclose($fp);

$fp= fopen("$LMSENSORSPATH/fan1","r");
$CPUFan=substr(fgets($fp),5);
fclose($fp);
#
# Calcola i valori delle tensioni arrotondati a 2 decimali
#
$P5V  = round((6.8/10+1)*$P5VR,2);
$P12V = round((28/10+1)*$P12VR,2);
$M12V = round(-(210/60.4)*$M12VR,2);
$M5V  = round(-(90.9/60.4)*$M12VR,2);
#
# Legge lo stato dell'UPS (APC) (una linea tipo: STATUS:    ONLINE)
#
$fp= fopen("$UPSSTATUSFILE","r");
do {
	$UPSSTATUS=fgets($fp);
} while (strpos($UPSSTATUS,"STATUS") === false);
$UPSSTATUS=rtrim(substr($UPSSTATUS,11));
fclose($fp);
#
# Legge e converte l'uptime in giorni, ore, minuti e secondi
#
$fp= fopen("$UPTIMEFILE","r");
$UPTIME=strtok(fgets($fp)," ");
$IDLETIME=strtok(" ");
fclose($fp);
$UP_SEC=(int)$UPTIME % 60;
$UPTIME=(int)($UPTIME/60);
$UP_MIN=$UPTIME % 60;
$UPTIME=(int)($UPTIME/60);
$UP_HRS=$UPTIME % 24;
$UP_DAY=(int)($UPTIME/24);
?>
<html>
<head>
  <title>Stato del server</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  <meta name="GENERATOR" content="status.php">
</head>
<body background="<?echo $MYURL?>/sfondo04.jpg">
<P ALIGN="CENTER"><FONT COLOR="#0e9cf1"><FONT SIZE="1"><B><IMG SRC="<? echo $MYURL?>/Gpcm-lgo.jpg" NAME="Immagine1" ALIGN="BOTTOM" WIDTH="100%" BORDER="0"></B></FONT></FONT></P>
<CENTER>
	<TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
		<TR>
			<TD WIDTH="100%" BGCOLOR="#008000">
				<P ALIGN="RIGHT"><FONT SIZE="5" STYLE="font-size: 24pt" COLOR="#ffffff"><B>Stato del server</B></FONT></P>
			</TD>
		</TR>
	</TABLE>
</CENTER>

<TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    <TR>
        <TD>
    	    <HR>
	</TD>
    </TR>
</TABLE>
<TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    <TR>
        <TD WIDTH="25%">
            <img src="<?echo $MYURL?>/FotoArmadio.jpg" ALT="L'armadio contenente il server al 26/9/2004" width="100%"  align="center" border="0">
        </TD>
	<TD WIDTH="1%"></TD>
	<TD WIDTH="64%">
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="100%">
                	<HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE="5" STYLE="font-size: 22pt"><font color="#ffffff">Data/Ora GMT</FONT></FONT>
		    </TD>
		    <TD WIDTH="65%">
                        <FONT SIZE="5" STYLE="font-size: 22pt"><font color="#00ff00">
<?
#
# Data/Ora
#
setlocale(LC_TIME, 'it_IT');
echo gmstrftime("%e %B %Y %H:%M:%S");
#
# --------
#
?>
			</FONT></FONT>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
		<TR>
    		    <TD WIDTH="35%">
        		<FONT SIZE="5" STYLE="font-size: 22pt"><font color="#ffffff">Uptime:
			</font></FONT>
		    </TD>
    		    <TD WIDTH="65%">
        		<FONT SIZE="5" STYLE="font-size: 22pt"><font color="#00ff00">
<?
#
# Uptime
#
			echo $UP_DAY, " giorni, ", $UP_HRS, " ore, ", $UP_MIN, " minuti";
?>
			</FONT></FONT>
		    </TD>
		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ffffff">V<SUB>CC</SUB></FONT>
            	    </TD>
		    <TD WIDTH="65%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#00ff00">+<?echo $Valim?> &nbsp;V
			</FONT>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ffffff">Temperatura</FONT>
            	    </TD>
		    <TD WIDTH="65%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#00ff00">+
<?
#
# Temperatura armadio
#
echo $Temp
?>
			&nbsp;&deg;C
			</FONT>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
    		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ffffff">Porta</font>
            	    </TD>
		    <TD WIDTH="32.5%">
			<FONT SIZE="5" STYLE="font-size: 22pt" color="#00ff00">
<?
#
# Porta I
#
if ($SW1 == 0) {
?>  

			    <img src="<?echo $MYURL?>/checkgreen.png" ALT="X" width=32 height=32 border=0>
<?
} else {
?>
                	    <img src="<?echo $MYURL?>/checkvuoto.png" ALT="&nbsp;" width=32 height=32 border=0>
<?
}

#
# -------
#
?>
			&nbsp;Chiusa
			</FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ff0000">
<?
#
# Porta II
#
if ($SW1 == 0) {
?>
			<img src="<?echo $MYURL?>/checkvuoto.png" ALT="&nbsp;" width=32 height=32 border=0>
<?
} else {
?>
			<img src="<? echo $MYURL?>/checkred.png" ALT="X" width=32 height=32 border=0>
<?
}
#
# --------
#
?>
			&nbsp;Aperta
			</FONT>
            	    </TD>
    		</TR>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ffffff">Ventola</FONT>
            	    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#00ff00">
<?
#
# Ventola I
#
if ($SW2 == 1) {
?>
			<img src="<?echo $MYURL?>/checkgreen.png" ALT="X">
<?
} else {
?>
			<img src="<?echo $MYURL?>/checkvuoto.png" ALT="&nbsp;">
<?
}
#
# ---------
#
?>
			&nbsp;Spenta
			</FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ff0000">
<?
#
# Ventola II
#
if ($SW2 == 1) {
?>
			<img src="<?echo $MYURL?>/checkvuoto.png" ALT="&nbsp;">
<?
} else {
?>
			<img src="<?echo $MYURL?>/checkred.png" ALT="X">
<?
}
#
# ----------
#
?>
			&nbsp;Accesa
			</FONT>
            	    </TD>
    		</TR>
    		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ffffff">Alimentazione</FONT>
            	    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#00ff00">
<?
#
# Rete I
#
if (strcmp($UPSSTATUS, "ONLINE") == 0) {
?>
			<img src="<? echo $MYURL?>/checkgreen.png" ALT="X">
<?
} else {
?>
			<img src="<?echo $MYURL?>/checkvuoto.png" ALT="&nbsp;">
<?
}
#
# ----
#
?>
			&nbsp;Rete</FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 22pt" color="#ff0000">
<?
#
# Rete II
#
if (strcmp($UPSSTATUS, "ONLINE") == 0) {
?>
			<img src="<?echo $MYURL?>/checkvuoto.png" ALT="&nbsp;">
<?
} else {
?>
			<img src="<?echo $MYURL?>/checkred.png" ALT="X">
<?
}
#
# ------
#
?>
			&nbsp;UPS
			</FONT>
            	    </TD>
    		</TR>
	    </TABLE>
	    <BR>
<?
#
# Stato PC
#
?>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
		<TR>
		    <TD WIDTH="100%">
            		<HR>
		    </TD>
		</TR>
	    </TABLE>
	    <BR>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
		<TR>
		    <TD WIDTH="35%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#ffffff">Stato del PC</font></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			T<SUB>CPU</SUB>=<?echo $CPUTemp?> &deg;C 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			T<SUB>SYS</SUB>=<?echo $SYSTemp?> &deg;C 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			Fan<SUB>CPU</SUB>=<?echo $CPUFan?> rpm 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			Fan<SUB>SYS</SUB>=<?echo $SYSFan?> rpm 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			V<SUB>CORE1</SUB>=<?echo $VCore1?> V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			V<SUB>TT</SUB>=<?echo $VCore2?> V 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			+3.3V=<?echo $P33V?> V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
            		<FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			+5V=<?echo $P5V?> V 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			+12V=<?echo $P12V?> V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
                        <FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			-5V=<?echo $M5V?> V 
			</FONT></FONT>
		    </TD>
		</TR>
    		<TR>
		    <TD WIDTH="35%">
		    </TD>
		    <TD WIDTH="32.5%">
                	<FONT SIZE="5" STYLE="font-size: 20pt"><font color="#00ff00">
			-12V=<? echo $M12V?> V 
			</FONT></FONT>
		    </TD>
		    <TD WIDTH="32.5%">
		    </TD>
		</TR>
	    </TABLE>
	    <TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
		<TR>
		    <TD WIDTH="100%">
                        <HR>
		    </TD>
		</TR>
	    </TABLE>
	</TD>
    </TR>
</TABLE>
<?
#
# Fine pagina e copyright
#
?>
<TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
	<TR>
		<TD WIDTH="100%">
                        <HR>
		</TD>
	</TR>
</TABLE>
<TABLE WIDTH="100%" BORDER="0" CELLPADDING="0" CELLSPACING="0">
	<TR>
		<TD WIDTH="100%">
			<P ALIGN="RIGHT">
			<font size="1" color="#808080">Pagina generata da status.php by I1EPJ</font>
			</P>
		</TD>
        </TR>
</TABLE>
</body>
</html>

